/* Lehasoft Tetris Mobile 2006
   Copyright (c) Alexey Inkin, Lehasoft (1996-2006), GetSoft.ru, leha@inkin.ru

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  */

package Game;

public class GameTicker implements Runnable
{
    private TetrisGame      m_objGame;
    private PauseWaiter     m_objPauseWaiter;
    private Thread          m_objThread;
    private int             m_nState;
    
    public GameTicker(TetrisGame objGame)
    {
        m_objGame = objGame;
        m_objPauseWaiter = new PauseWaiter();
        m_objThread = new Thread(this);
        m_objThread.start();
    }
    
    public void run()
    {
        try
        {
            while (true)
            {
                m_objPauseWaiter.waitForPauseCanceled();
                if (!m_objGame.tick(false))
                    pause();
                Thread.sleep(m_objGame.getTicksInterval());
            }
        }
        catch (Exception e)
        {
            System.out.println(e);
        }
    }
    
    public void pause()
    {
        m_objPauseWaiter.pause();
    }
    
    public void resume()
    {
        m_objPauseWaiter.resume();
    }
}