/* Lehasoft Tetris Mobile 2006
   Copyright (c) Alexey Inkin, Lehasoft (1996-2006), GetSoft.ru, leha@inkin.ru

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  */

package Interface;

import Main.*;
import Interface.*;
import javax.microedition.lcdui.*;

public class AboutCanvas extends Canvas implements CommandListener
{
    private int                 m_nWidth;
    private int                 m_nHeight;
    private Command             m_cmdOK                 = new Command("OK", Command.SCREEN, 0);
    private Tetris              m_objApplication;
    private MostFitImage        m_objMostFitImage       = new MostFitImage();
    private ColorThemeKeeper    m_objColorThemeKeeper;
    private Image               m_imgBackground;
    private boolean             m_bInitialized          = false;
    
    public AboutCanvas(Tetris objApplication)
    {
        m_objApplication = objApplication;
        
        m_nWidth = getWidth();
        m_nHeight = getHeight();
        
        addCommand(m_cmdOK);
        setCommandListener(this);
        setTitle("Lehasoft Tetris");
    }
    
    public void commandAction(Command       cmd,
                              Displayable   d)
    {
        m_objApplication.enterMenu();
    }
    
    public void initialize()
    {
        Graphics    g;
        Image       imgAbout;

        if (!m_bInitialized)
        {
            m_objMostFitImage.addImage(48, 48, "/Images/about48.png");
            m_objMostFitImage.addImage(64, 64, "/Images/about64.png");
            m_objMostFitImage.addImage(96, 96, "/Images/about96.png");
            m_objMostFitImage.addImage(128, 128, "/Images/about128.png");
            m_objMostFitImage.addImage(160, 160, "/Images/about160.png");
            
            m_objMostFitImage.loadMostFitImage(m_nWidth, m_nHeight);
            imgAbout = m_objMostFitImage.getImage();
            
            g = m_imgBackground.getGraphics();
            g.drawImage(
                imgAbout,
                (m_nWidth - m_objMostFitImage.getWidth()) / 2,
                (m_nHeight - m_objMostFitImage.getHeight()) / 2,
                Graphics.LEFT | Graphics.TOP);
            m_bInitialized = true;
        }
    }
    
    protected void paint(Graphics	g)
    {
        g.drawImage(m_imgBackground, 0, 0, Graphics.LEFT | Graphics.TOP);
    }
    
    public void setColorThemeKeeperObject(ColorThemeKeeper objColorThemeKeeper)
    {
        Graphics g;
        
        m_objColorThemeKeeper = objColorThemeKeeper;
        m_imgBackground = Image.createImage(m_nWidth, m_nHeight);
        g = m_imgBackground.getGraphics();
        g.drawImage(objColorThemeKeeper.getBackgroundImage(), 0, 0, Graphics.LEFT | Graphics.TOP);
    }
}
