/* Lehasoft Tetris Mobile 2006
   Copyright (c) Alexey Inkin, Lehasoft (1996-2006), GetSoft.ru, leha@inkin.ru

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  */

package Interface;

import java.util.*;
import javax.microedition.lcdui.*;

public class MostFitImage
{
    Vector  m_lstImagesInfo;
    Image   m_imgMostFit;
    
    public MostFitImage()
    {
        m_lstImagesInfo = new Vector();
    }
    
    public void addImage(int    nWidth,
                         int    nHeight,
                         String strPath)
    {
        m_lstImagesInfo.addElement(new ImageInfo(nWidth, nHeight, strPath));
    }
    
    public int getHeight()
    {
        return m_imgMostFit.getHeight();
    }
    
    public Image getImage()
    {
        return m_imgMostFit;
    }
    
    private static int getImagesDelta(int  nFirstWidth,
                                      int  nFirstHeight,
                                      int  nSecondWidth,
                                      int  nSecondHeight)
    {
        return (nFirstWidth - nSecondWidth + nFirstHeight - nSecondHeight);
    }
    
    public int getWidth()
    {
        return m_imgMostFit.getWidth();
    }
    
    public void loadMostFitImage(int    nWidth,
                                 int    nHeight)
    {
        int         i;
        int         nCurrentWidth;
        int         nCurrentHeight;
        int         nDelta;
        ImageInfo   objFitInfo          = null;
        int         nFitDelta           = 0;
        boolean     bFoundOneFit        = false;
        ImageInfo   objNotFitInfo       = null;
        int         nNotFitDelta        = 0;
        boolean     bFoundOneNotFit     = false;
        ImageInfo   objPartialFitInfo   = null;
        int         nPartialFitDelta    = 0;
        boolean     bFoundOnePartialFit = false;
        ImageInfo   objImageInfo;
        Enumeration objEnumeration;
        
        objEnumeration = m_lstImagesInfo.elements();
        
        while (objEnumeration.hasMoreElements())
        {
            objImageInfo = (ImageInfo)objEnumeration.nextElement();
            nCurrentWidth = objImageInfo.getWidth();
            nCurrentHeight = objImageInfo.getHeight();
            
            nDelta = getImagesDelta(nWidth, nHeight, nCurrentWidth, nCurrentHeight);
            if (nCurrentWidth <= nWidth && nCurrentHeight <= nHeight)
            {
                if (!bFoundOneFit || nDelta < nFitDelta)
                {
                    bFoundOneFit = true;
                    objFitInfo = objImageInfo;
                    nFitDelta = nDelta;
                }
            }
            else if (nCurrentWidth > nWidth && nCurrentHeight > nHeight)
            {
                if (!bFoundOneNotFit || nDelta > nNotFitDelta)
                {
                    bFoundOneNotFit = true;
                    objNotFitInfo = objImageInfo;
                    nNotFitDelta = nDelta;
                }
            }
            else
            {
                if (!bFoundOnePartialFit || Math.abs(nDelta) < Math.abs(nPartialFitDelta))
                {
                    bFoundOnePartialFit = true;
                    objPartialFitInfo = objImageInfo;
                    nPartialFitDelta = nDelta;
                }
            }
        }
        if (bFoundOneFit)
            m_imgMostFit = objFitInfo.loadImage();
        else if (bFoundOneNotFit)
            m_imgMostFit = objNotFitInfo.loadImage();
        else if (bFoundOnePartialFit)
            m_imgMostFit = objPartialFitInfo.loadImage();
    }
}